<?php
namespace Ebourgogne\Ebourgognegdd\Controller;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * UserController
 */
class UserController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{
    
    /**
     * myObjectRepository
     *
     * @var Ebourgogne\Ebourgognegdd\Domain\Repository\UserRepository
     * @inject
     */
    protected $userRepository;
    
    /**
     * @var \TYPO3\CMS\Extbase\Persistence\PersistenceManagerInterface
     * @inject
     */
    protected $persistenceManager;

    /**
    * @var string
    */
    protected $boBaseUrl = 'https://monservicepublic.e-bourgogne.fr/api/gdd/check';

    /**
    * @var string
    */
    protected $foBaseUrl = 'https://monguide.e-bourgogne.fr/api/v1/guide/';
        
    
   
    public function showAction()
    {
        $tabObjs = $this->userRepository->findAll();
        $newTab = array(); 
        for($i = 0; $i<count($tabObjs);$i++){
            if(!empty($tabObjs[$i]->getApikeyset())){
                $tmpObj = $tabObjs[$i];     
            }               
        }
        list($organismId) = explode(":", base64_decode($tmpObj->getApikeyset()));

        $uidObj = $this->settings['gddset'];

        $tmpObj = $this->userRepository->findByUid($uidObj);

        $generatedUrl = $this->foBaseUrl.$tmpObj->getNamefiche().'/'.$tmpObj->getDataid().'/'.$organismId.'.js?divId=iframeFlag-15';

        if(!empty($this->settings['css'])){
            $generatedUrl = $generatedUrl.'?customCss='.(string)$this->settings['css'];
        }

        $this->view->assign('urlGenerated',$generatedUrl);
    }
    
    /**
     * action apiset
     *
     * @param \Ebourgogne\Ebourgogntfkey\Domain\Model\User $user
     * @return void
     */
    public function apisetAction(\Ebourgogne\Ebourgognegdd\Domain\Model\User $user = NULL)
    {
        $tabObjs = $this->userRepository->findAll();
        $adresseimg = '../typo3conf/ext/ebourgognegdd/Resources/Public/Icons/logo-big.png';
        $this->view->assign('img', $adresseimg);
        if (count($tabObjs) > 1) {
            $j=0;
            for($i= 0; $i<count($tabObjs);$i++)
            {
                if(!empty($tabObjs[$i]->getApikeyset()))
                {
                    $j++;
                    $tmpObj = $tabObjs[$i];
                }
                    
            }

            if($j>=2){
                $this->userRepository->removeAll();
                $this->persistenceManager->persistAll();
                $tmpObj = null;
            }
        } else {
            $tmpObj = $tabObjs[0];
        }
        if (!empty($user)) {
            $apikey = $user->getApikeyset();
            $headers = array(
                "ebou-api-key" . ': ' . $apikey
            );

            $curl = curl_init();
            curl_setopt( $curl, CURLOPT_URL, $this->boBaseUrl );
            curl_setopt( $curl, CURLOPT_RETURNTRANSFER, true );
            curl_setopt( $curl, CURLOPT_HTTPHEADER, $headers );
            curl_setopt(
                $curl,
                CURLOPT_PROXY,
                $GLOBALS['TYPO3_CONF_VARS']['HTTP']['proxy_host'] . ":" . $GLOBALS['TYPO3_CONF_VARS']['HTTP']['proxy_port']
            );
                
            $file = curl_exec( $curl );
            curl_close( $curl );


            if ($file == 'OK') {
                //On teste si l'objet n'existe pas en base
                if (empty($tmpObj)) {
                    $this->userRepository->add($user);
                    $this->persistenceManager->persistAll();
                } else {
                    //On update l'objet
                    $tmpObj->setApikeyset($user->getApikeyset());
                    $this->userRepository->update($tmpObj);
                    $this->persistenceManager->persistAll();
                }
                $this->view->assign('message', 'Votre clé a bien été mise à jour.');
                $this->view->assign('apikey', $user->getApikeyset());
                $this->view->assign('gliphi', ' glyphicon-ok');
                $this->view->assign('style', 'color:green;');
            } else {
                $this->view->assign('gliphi', ' glyphicon-remove');
                if (empty($tmpObj)) {
                    $this->view->assign('apikey', '');
                } else {
                    $this->view->assign('apikey', $tmpObj->getApikeyset());
                }
                $this->view->assign('message', 'Il y a eu une erreur dans la vérification de votre clé.');
                $this->view->assign('style', 'color:red;');
            }
        } else {
            if (empty($tmpObj)) {
                $this->view->assign('message', 'Entrez votre clé ci-dessous.');
                $this->view->assign('gliphi', ' glyphicon-remove');
            } else {
                $this->view->assign('message', 'Vous pouvez éditer votre clé ici.');
                $this->view->assign('gliphi', ' glyphicon-ok');
                $this->view->assign('apikey', $tmpObj->getApikeyset());
            }
        }
    }
    
    /**
     * action gddset
     *
     * @return void
     */
    public function gddsetAction(\Ebourgogne\Ebourgognegdd\Domain\Model\User $user = NULL)
    {
        $tabObjs = $this->userRepository->findAll();
        $newTab = array(); 

        for($i = 0; $i<count($tabObjs);$i++){
            if(!empty($tabObjs[$i]->getApikeyset())){
                $tmpObj = $tabObjs[$i];     
            }               
        }

        $adresseimg = '../typo3conf/ext/ebourgognegdd/Resources/Public/Icons/logo-big.png';
        $this->view->assign('img', $adresseimg);

        $adressecss = '../typo3conf/ext/ebourgognegdd/Resources/Private/Templates/css/settings.css';
        $this->view->assign('css', $adressecss);

        $adressejs = '../typo3conf/ext/ebourgognegdd/Resources/Private/Templates/JavaScript/settings.js';
        $this->view->assign('js', $adressejs);

        list($organismId) = explode(":", base64_decode($tmpObj->getApikeyset()));

        $flux_type = array( 
            'asso' => 'Association', 
            'part' => 'Particulier', 
            'pro' => 'Professionel' 
        );

        $this->view->assign('flux_type', $flux_type);
        $this->view->assign('organism', $tmpObj);
        $this->view->assign('organismId', $organismId);

        if(!empty($user)){
            $this->userRepository->add($user);
            $this->persistenceManager->persistAll();
            $this->view->assign('message', 'Votre configuration a bien été enregistrée.');  
        }else{
            $this->view->assign('message', 'Configurez ici votre GDD, ils seront disponible dans votre interface.');
        }
    }
    
    /**
     * action gddud
     *
     * @return void
     */
    public function gddudAction()
    {
        if(!empty((string)$_POST["objToDelete"])){
            $objTmp = $this->userRepository->findByUid((string)$_POST["objToDelete"]);

            if(!empty($objTmp)){
                if(empty($objTmp->getApikeyset())){
                    $this->userRepository->remove($objTmp);
                    $this->persistenceManager->persistAll();
                    $this->view->assign('message', 'Votre objet a bien été supprimé.');
                }
            }
        }else {
            $this->view->assign('message', 'Veuillez sélectionner un objet à supprimer.');
        }

        $obj = $this->userRepository->findAll();

        for($i = 0; $i < count($obj); $i++){
            $tmpObj[$i] = $obj[$i+1];
        }

        $this->view->assign('listObj',$obj);
    }

}